namespace TwinCitiesCodeCamp.SmoothOperator.Core.Domain
{
    /// <summary>
    /// Interface for a customer. 
    /// </summary>
    public interface ICustomer
    {
        /// <summary>
        /// The customers identifier
        /// </summary>
        int Id { get; set; }

        /// <summary>
        /// The first name of the customer. 
        /// </summary>
        string FirstName { get; set;  }

        /// <summary>
        /// The last name of the customer. 
        /// </summary>
        string LastName { get; set; }

        /// <summary>
        /// The level of membership that the customer has. 
        /// <remarks>
        /// Customers will start off at the lowest membership level, <see cref="Membershiplevel.Silver"/>
        /// and as they progress through purchases they will climb the membership level latter moving 
        #pragma warning disable 1574
        /// to <see cref="Membershiplevel.Gold"/> and then to <see cref="Membershiplevel.Platinum"/></remarks>
        #pragma warning restore 1574
        /// </summary>
        MembershipLevel MembershipLevel { get; set; }

    }
}