using System.Collections.Generic;

namespace TwinCitiesCodeCamp.SmoothOperator.Core.Domain
{
    /// <summary>
    /// Interface for the order. 
    /// </summary>
    public interface IOrder
    {
        /// <summary>
        /// The Customer who has placed the order.
        /// </summary>
        Customer Customer { get; set; }

        /// <summary>
        /// The list of <see cref="ILineItem"/> that are part of the order. 
        /// </summary>
        List<LineItem> LineItems { get; set; }

        /// <summary>
        /// The total of all of the <see cref="LineItems"/>
        /// </summary>
        double OrderTotal { get; set;  }

        /// <summary>
        /// The discount that is applied to the order. 
        /// </summary>
        decimal Discount { get; set; }

        /// <summary>
        /// The Name of the queue that the order should attach to.
        /// </summary>
        string MessageQueueName { get; set; }

        /// <summary>
        /// The total number of items
        /// </summary>
        int TotalQuantity { get; set;  }
        
    }
}