﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TwinCitiesCodeCamp.SmoothOperator.Core.Domain;

namespace TwinCitiesCodeCamp.SmoothOperator.ExampleLegacy
{
    public class OrderProcessor
    {
        #region Legacy V1

        //public void ProcessOrder(IOrder order)
        //{
        //    switch (order.Customer.MembershipLevel)
        //    {
        //        case MembershipLevel.Platinum:
        //            // ... do some platinum member work
        //            break;
        //        case MembershipLevel.Gold:
        //            // .. do some gold member work 
        //            break;
        //        default:
        //            // case MembershipLevel.Silver fall into default. aka: standard members
        //            // do some ... standard member ... work. 
        //            break;
        //    }
        //}

        #endregion

        #region Legacy V2

        //public void ProcessOrder(IOrder order)
        //{
        //    // If customers order total over 10K, give them super duper 
        //    // platinum level service. Heck, roll out the red carpet. 
        //    if (order.OrderTotal >= 10000)
        //    {
        //        order.Customer.MembershipLevel = MembershipLevel.Platinum; 
        //    }

        //    switch (order.Customer.MembershipLevel)
        //    {
        //        case MembershipLevel.Platinum:
        //            // ... do some platinum member work
        //            break;
        //        case MembershipLevel.Gold:
        //            // .. do some gold member work 
        //            break;
        //        default:
        //            // case MembershipLevel.Silver fall into default. aka: standard members
        //            // do some ... standard member ... work. 
        //            break;
        //    }
        //}

        #endregion

        #region Legacy V3

        //public void ProcessOrder(IOrder order)
        //{
        //    // If customers order total over 10K, give them super duper 
        //    // platinum level service. Heck, roll out the red carpet. 
        //    if (order.OrderTotal >= 10000)
        //    {
        //        order.Customer.MembershipLevel = MembershipLevel.Platinum;
        //    }

        //    // Total Quantity updgrade
        //    if(order.TotalQuantity >= 1000)
        //    {
        //        order.Customer.MembershipLevel = MembershipLevel.Platinum;
        //    }

        //    switch (order.Customer.MembershipLevel)
        //    {
        //        case MembershipLevel.Platinum:
        //            // ... do some platinum member work
        //            break;
        //        case MembershipLevel.Gold:
        //            // .. do some gold member work 
        //            break;
        //        default:
        //            // case MembershipLevel.Silver fall into default. aka: standard members
        //            // do some ... standard member ... work. 
        //            break;
        //    }
        //}

        #endregion

        #region Legacy V4

        public void ProcessOrder(IOrder order)
        {
            // If customers order total over 10K, give them super duper 
            // platinum level service. Heck, roll out the red carpet. 
            if (order.OrderTotal >= 10000)
            {
                order.Customer.MembershipLevel = MembershipLevel.Platinum;
            }

            // Total Quantity updgrade
            if (order.TotalQuantity >= 1000)
            {
                order.Customer.MembershipLevel = MembershipLevel.Platinum;
            }

            // Total Line Item Quantity Upgrade 
            if(order.LineItems.Count >= 100)
            {
                order.Customer.MembershipLevel = MembershipLevel.Platinum;
            }

            switch (order.Customer.MembershipLevel)
            {
                case MembershipLevel.Platinum:
                    // ... do some platinum member work
                    break;
                case MembershipLevel.Gold:
                    // .. do some gold member work 
                    break;
                default:
                    // case MembershipLevel.Silver fall into default. aka: standard members
                    // do some ... standard member ... work. 
                    break;
            }
        }

        #endregion

    }
}
