﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TwinCitiesCodeCamp.SmoothOperator.Core.Domain;

namespace TwinCitiesCodeCamp.SmoothOperator.OrderSubmitter
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
            LoadCustomerTypes(); 
        }

        private void LoadCustomerTypes()
        {
            customerTypeCombo.ItemsSource = Enum.GetNames(typeof (MembershipLevel)); 
        }

        private void sendOrdersButton_Click(object sender, RoutedEventArgs e)
        {
            // Create Order
            var order = new Order();

            // Get the membership level
            var membershipLevel =
                (MembershipLevel)
                Enum.Parse(typeof (MembershipLevel), customerTypeCombo.SelectedValue.ToString());

            // Create Customer
            var customer = new Customer()
                               {
                                   FirstName = String.Format("{0}", customerTypeCombo.SelectedValue),
                                   LastName = "Customer",
                                   Id = 1,
                                   MembershipLevel = membershipLevel
                               };
            order.Customer = customer; 

            List<LineItem> lineItems = new List<LineItem>();
            for (int i = 0; i < Convert.ToInt32(lineItemsTextBox.Text); i++)
            {
                var lineItem = new LineItem()
                                   {
                                       Quantity = Convert.ToInt32(quantityTextBox.Text),
                                       Name = String.Format("{0}LineItem", customerTypeCombo.SelectedValue),
                                       Price = Convert.ToDouble(itemPriceTextBox.Text)
                                   }; 
                lineItems.Add(lineItem);
            }
            order.LineItems = lineItems.ToArray(); 

            // Send off order 
            OrderServiceClient svc = new OrderServiceClient();
            svc.RouteOrder(order);

            

        }
    }
}
