﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Management;
using System.Messaging;
using System.Text;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace TwinCitiesCodeCamp.SmoothOperator.QueueMonitor
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        private DispatcherTimer timer = null;

        public Window1()
        {
            InitializeComponent();
            LoadQueues(); 
        }

        private void LoadQueues()
        {
            MessageQueue[] queues = MessageQueue.GetPrivateQueuesByMachine(Environment.MachineName);
            messageQueues.ItemsSource = queues.ToList().Select(q => q.QueueName);
        }

        private void messageQueues_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            timer = new DispatcherTimer();
            timer.Interval = new TimeSpan(0, 0, 0, 2); 
            timer.Tick += GetMessagesInQueue;
            timer.Start();
        }

        private void GetMessagesInQueue(object targetQueue, EventArgs e) 
        {
            string targetQueueName = String.Format(@"{0}\{1}", Environment.MachineName, messageQueues.SelectedValue).ToLowerInvariant();
            // use WMI to get number of messages in queue. 
            bool queueFound = false; 
            var query = new ObjectQuery("Select * From Win32_PerfRawData_MSMQ_MSMQQueue");
            var searcher = new ManagementObjectSearcher(query);
            ManagementObjectCollection results = searcher.Get();

            foreach (var result in results)
            {
                if (result["Name"].ToString() == targetQueueName)
                {
                    this.queueCounterLabel.Content = result["MessagesInQueue"].ToString();
                    queueFound = true;
                }
            }

            if (queueFound == false)
            {
                this.queueCounterLabel.Content = 0; 
            }

        }

        private void closeButton_Click(object sender, RoutedEventArgs e)
        {
            this.Close(); 
        }
    }
}
