using Microsoft.VisualStudio.TestTools.UnitTesting;
using TwinCitiesCodeCamp.SmoothOperator.Core.Domain;

namespace TwinCitiesCodeCamp.SmoothOperator.UnitTests
{
    [TestClass]
    public class LineItemTests
    {
        private readonly string NAME_OF_PRODUCT = "NameOfProduct";
        private readonly int QUANTITY = 10;
        private readonly double PRICE = 25.99d;

        [TestMethod]
        public void Line_item_should_maintain_state()
        {
            ILineItem lineItem = new LineItem
                                     {
                                         Name = NAME_OF_PRODUCT, 
                                         Quantity = QUANTITY, 
                                         Price = PRICE
                                     };

            Assert.AreEqual(lineItem.Name, NAME_OF_PRODUCT);
            Assert.AreEqual(lineItem.Price, PRICE);
            Assert.AreEqual(lineItem.Quantity, QUANTITY);


        }

        [TestMethod]
        public void Line_Item_Should_initialize_through_constructor()
        {
            var lineItem = new LineItem(QUANTITY, NAME_OF_PRODUCT, PRICE);
            Assert.AreEqual(lineItem.Name, NAME_OF_PRODUCT);
            Assert.AreEqual(lineItem.Price, PRICE);
            Assert.AreEqual(lineItem.Quantity, QUANTITY);
        }
    }
}