using Microsoft.Rules.Samples.ExternalRuleSetLibrary;
using Microsoft.Rules.Samples.ExternalRuleSetService;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Rhino.Mocks;
using TwinCitiesCodeCamp.SmoothOperator.Core.Domain;

namespace TwinCitiesCodeCamp.SmoothOperator.UnitTests
{
    [TestClass]
    public class OrderProcessorTests
    {

        [TestInitialize]
        public void Setup()
        {
            
        }

        [TestMethod]
        public void OrderProcessor_should_handle_order()
        {
            var ruleSetService = MockRepository.GenerateStub<IExternalRuleSetService>(); 
            var customer = MockRepository.GenerateStub<ICustomer>();
            var lineItem = MockRepository.GenerateStub<ILineItem>(); 
            var order = MockRepository.GenerateStub<IOrder>();
            order.Customer = customer;
            order.LineItems.Add(lineItem); 

            IOrderRouter router = new OrderRouter(ruleSetService, new RuleSetInfo()); 
            router.Execute(order);
        }
    }
}