using NUnit.Framework;
using NUnit.Framework.SyntaxHelpers;
using TwinCitiesCodeCamp.SmoothOperator.Core;

namespace TwinCitiesCodeCamp.SmoothOperator.UnitTests
{
    [TestFixture]
    public class CustomerTests
    {
        private readonly string FIRST_NAME = "FirstName";
        private readonly string LAST_NAME = "LastName";

        [Test]
        public void CustomerShouldMaintainProperties()
        {
            ICustomer customer = new Customer();
            customer.FirstName = FIRST_NAME;
            customer.LastName = LAST_NAME;
            customer.ID = int.MinValue;
            customer.MembershipLevel = Membershiplevel.Platinum;

            Assert.That(customer.FirstName, Is.EqualTo(FIRST_NAME));
            Assert.That(customer.LastName, Is.EqualTo(LAST_NAME));
            Assert.That(customer.ID, Is.EqualTo(int.MinValue));
            Assert.That(customer.MembershipLevel, Is.EqualTo(Membershiplevel.Platinum));
           
        }
    }
}