using NUnit.Framework;
using NUnit.Framework.SyntaxHelpers;
using TwinCitiesCodeCamp.SmoothOperator.Core;

namespace TwinCitiesCodeCamp.SmoothOperator.UnitTests
{
    [TestFixture]
    public class LineItemTests
    {
        private readonly string NAME_OF_PRODUCT = "NameOfProduct";
        private readonly int QUANTITY = 10;
        private readonly double PRICE = 25.99d;

        [Test]
        public void Line_item_should_maintain_state()
        {
            ILineItem lineItem = new LineItem
                                     {
                                         Name = NAME_OF_PRODUCT, 
                                         Quantity = QUANTITY, 
                                         Price = PRICE
                                     };

            Assert.That(lineItem.Name, Is.EqualTo(NAME_OF_PRODUCT));
            Assert.That(lineItem.Price, Is.EqualTo(PRICE));
            Assert.That(lineItem.Quantity, Is.EqualTo(QUANTITY));


        }

        [Test]
        public void Line_Item_Should_initialize_through_constructor()
        {
            var lineItem = new LineItem(QUANTITY, NAME_OF_PRODUCT, PRICE);
            Assert.That(lineItem.Name, Is.EqualTo(NAME_OF_PRODUCT));
            Assert.That(lineItem.Price, Is.EqualTo(PRICE));
            Assert.That(lineItem.Quantity, Is.EqualTo(QUANTITY));
        }
    }
}