using NUnit.Framework;
using NUnit.Framework.SyntaxHelpers;
using Rhino.Mocks;
using TwinCitiesCodeCamp.SmoothOperator.Core;

namespace TwinCitiesCodeCamp.SmoothOperator.UnitTests
{
    [TestFixture]
    public class OrderTests
    {
        MockRepository mockery = new MockRepository();
        private ICustomer customerStub;
        private readonly int QUANTITY = 10;

        [SetUp]
        public void Setup()
        {
            customerStub = MockRepository.GenerateStub<ICustomer>(); 
            
        }

        [Test]
        public void OrderTotalShouldCalculateTotalCost()
        {
            IOrder order = new Order { Customer = customerStub };

            for (var i = 0; i < QUANTITY; i++)
            {
                var lineItem = mockery.Stub<ILineItem>();
                lineItem.Name = "Test";
                lineItem.Price = 10;
                lineItem.Quantity = 5; 

                order.LineItems.Add(lineItem);
            }

            Assert.That(order.Customer, Is.EqualTo(customerStub));
            Assert.That(order.LineItems.Count, Is.EqualTo(QUANTITY));
            Assert.That(order.OrderTotal, Is.EqualTo(500));
                            
        }

    }
}